/*
  Made By © Mustafa López & el "Rateret-Brut" del Culebrón-Xinorlet-Pinos (Alacant) 2020
*/

#include "hmg.ch"
#include "Remove_USB.prg"

FUNCTION Main

 SET CODEPAGE TO UNICODE

  PRIVATE cDisk         // ---> "F:"
  PRIVATE lExist        := .F.
  PRIVATE nSetErrorMode := 0
  PRIVATE aChecb , CDRIVELETTER

  PRIVATE nBitMask := GetLogicalDrives ()
  PRIVATE aDrives := {}
  PRIVATE i
  PRIVATE cTexto := "" 
  PRIVATE nType , unit

  PRIVATE cVolName
  PRIVATE nSerNum
  PRIVATE nMaxName
  PRIVATE nFlags
  PRIVATE cFATName
  PRIVATE cDiskSerial
  PRIVATE cInfo := ""

*---------------------------------------------------------------------*

   FileDelete("USB-Drive.mem")

   IF ! FILE("USB-Drive.mem")
        Detecta()
   ENDIF

*---------------------------------------------------------------------*

  DEFINE WINDOW Form_1               ;
         AT 0,0                      ;
         WIDTH 315 HEIGHT 305        ;
         TITLE ''                    ;   
         ICON 'Logo'                 ;
         NOSYSMENU NOMINIMIZE NOMAXIMIZE NOSIZE ;          
         MAIN                        ;           
         ON INIT (lExistUSB( cDisk ) , eTVer_1() )

         ON KEY ESCAPE ACTION  EIXIDA_EXIT()   


     RESTORE FROM 'USB-Drive.mem'  ADDITIVE  

     cDisk :=  ALLTRIM(unit) + ":"

  IF lExistUSB( cDisk )

      DEFINE IMAGE Ima_Pen_1
           ROW 019 ; COL 019 ; WIDTH 274 ; HEIGHT 090  
           PICTURE "Resource\Imagen10.jpg"
           STRETCH .T.
       END IMAGE

       @ 043,124 LABEL Label_01x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 70 HEIGHT 60  BACKCOLOR { 093,167,228 }                  
       @ 036,151 LABEL Label_02x VALUE cDisk FONT "Arial" SIZE 37 BOLD ITALIC WIDTH 70 HEIGHT 70  BACKCOLOR { 093,167,228 }                  

       HMG_ChangeWindowStyle ( GetControlHandle("Ima_Pen_1","Form_1"), LVS_REPORT, NIL, .T. )
 
  ELSE

      DEFINE IMAGE Ima_Pen_2
           ROW 019 ; COL 019 ; WIDTH 274 ; HEIGHT 090 
           PICTURE "Resource\Imagen11.jpg"
           STRETCH .T.
       END IMAGE

       @ 043,124 LABEL Label_01x VALUE "-"+ HB_UChar(187)  FONT "Arial" SIZE 20 BOLD ITALIC WIDTH 70 HEIGHT 60  BACKCOLOR { 093,167,228 }                  
       @ 036,151 LABEL Label_02x VALUE cDisk FONT "Arial" SIZE 37 BOLD ITALIC WIDTH 70 HEIGHT 70  BACKCOLOR { 093,167,228 }                  
       @ 144,032 Label Label_03x Value "" FONT "Arial" SIZE 14 BOLD ITALIC WIDTH 250 HEIGHT 17  BACKCOLOR  {183,214,255}  


       HMG_ChangeWindowStyle ( GetControlHandle("Ima_Pen_2","Form_1"), LVS_REPORT, NIL, .T. )

  ENDIF


      RESTORE FROM 'USB-Drive.mem' ADDITIVE  

      DEFINE EDITBOX Edit_01
             ROW    125                       
             COL    019            
             WIDTH  273    
             HEIGHT 063
             VALUE  cTexto
             FONTNAME 'Courier New'
             FONTSIZE 9
             TOOLTIP ""
             FONTBOLD .T.
             FONTITALIC .F.
             DISABLEDBACKCOLOR {183,214,255}   
             DISABLEDFONTCOLOR {000,000,000} 
             TABSTOP .T.
             VISIBLE .T.
             READONLY .T.
             HSCROLLBAR .F.
             VSCROLLBAR .F.
             BACKCOLOR {183,214,255}        
             FONTCOLOR Nil
      END EDITBOX

      HMG_ChangeWindowStyle ( GetControlHandle("Edit_01","Form_1"), LVS_REPORT, NIL, .T. )


         DEFINE CHECKBOX Check_3
                ROW    195 
                COL    075  
                WIDTH  160 
                CAPTION SPACE(4)+"Eject USB Drive " + UNIT +":  ?"  
                VALUE  .F. 
                FONTNAME "Arial"
                FONTSIZE 9
                FONTBOLD .T. 
                FONTITALIC .F.    
                TOOLTIP ""
                ONCHANGE xTraWavQ()
         END CHECKBOX

         DEFINE BUTTON Button_01      
                ROW    227  
		COL    090
		WIDTH  131 
		HEIGHT 032
                CAPTION SPACE(09)-"&Exit"
		ACTION EIXIDA_EXIT() 
                FONTNAME "Arial"
                FONTSIZE 9
                TOOLTIP "Exit"
                FONTBOLD .T.
                FONTITALIC .T.
                PICTURE "Resource\Exit.bmp"
                PICTALIGNMENT  LEFT  
         END BUTTON


  END WINDOW

      Form_1.Check_3.SetFocus

      SETWINDOWCURSOR ( Form_1.Button_01.Handle, "Resource\SmoothHand.cur")  
  
  CENTER WINDOW Form_1
  ACTIVATE WINDOW Form_1

Return Nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*--------------------------------------------------------------------------------------------*
 FUNCTION Detecta()
*--------------------------------------------------------------------------------------------*
 For i := 1 To 32
   If IsBit ( nBitMask , i )                 // <------ função IsBit da biblioteca LIBCT.LIB
      Aadd( aDrives, Chr(64+i)+":\" )
   EndIf
 Next i


 For i := 1 To Len( aDrives )
    GetVolumeInformation( aDrives[i], @cVolName, @nSerNum , @nMaxName , @nFlags , @cFATName )

    nType := GetDriveType(aDrives[i])
    If nType=2 .and. lExistUSB( Substr(aDrives[i],1,1) )         
         cTexto := cTexto + ;
                 SPACE(03)+"Unidad: " +  Substr(aDrives[i],1,2) + CRLF +  Space(3) + ;
	         "Volume de Unidad: " +  ALLTRIM(cVolName) + CRLF + Space(3) + ;
		 "Serial: "+ HB_VALTOSTR(VOLSERIAL(aDrives[i])) +" "+Chr(40)+Stuff( NumToHex( VOLSERIAL(aDrives[i]) ), 5, 0, "-" ) + Chr(41) + Chr(13) + Chr(10)
    Endif

 Next i


  unit :=   Aadd( aDrives, Chr(64+6) )     // <------- Unidad F:
  SAVE ALL LIKE unit* TO 'USB-Drive.mem' 


Return Nil


*--------------------------------------------------------------------------------------------*
 Function xTraWavQ()
*--------------------------------------------------------------------------------------------*

    RESTORE FROM 'USB-Drive.mem' ADDITIVE 
  
    Form_1.Check_3.CAPTION := SPACE(4)+"Eject USB Drive " + UNIT +":  ?" 
 
    aChecb  := ( IIF(Form_1.Check_3.Value,"True","False") )
 
    IF aChecb = "True"  
 
          Form_1.Check_3.CAPTION :=  SPACE(4)+"Eject USB Drive " + UNIT +":  Yes" 
          eMenSSagen()

    ENDIF

 Return Nil

*--------------------------------------------------------------------------------------------* 
 FUNCTION eMenSSagen()
*--------------------------------------------------------------------------------------------* 
 
 #define MB_ICONASTERISK 64
 #define MB_ICONEXCLAMATION 0x30
 #define MB_ICONWARNING 0x30
 #define MB_ICONERROR 16
 #define MB_ICONHAND 16
 #define MB_ICONQUESTION 32

*------------------------------------------*

  RESTORE FROM 'USB-Drive.mem' ADDITIVE   

  PRIVATE cText  :=  CRLF + SPACE(3) + "Proceed to Remove USB The Drive " + UNIT +":  ?"  + CRLF + CRLF + ; 
                           SPACE(3) + "Atención !  Este Modo Desconecta  Unidad pero el PenDrive" + ;
                           SPACE(4) + " queda Encendico "+ CRLF + CRLF + ; 
                           SPACE(3) + "Attention ! This Mode Disconnects Unit   but the PenDrive" + ;
                                      "        Remains ON"

  PRIVATE cTexp  := "Atenttion ! , Remove USB The Drive " + UNIT +":  ?" 


  wapi_MessageBox( wapi_GetActiveWindow(), cText,cTexp ,MB_ICONQUESTION )    //<-  pon el icon que quieras ?  sample  MB_ICONHAND 


  Return Nil



*--------------------------------------------------------------------------------------------* 
 FUNCTION  EIXIDA_EXIT()
*--------------------------------------------------------------------------------------------* 

  IF aChecb = "True"  
         
         REMOVE()         
         Form_1.Release
  ELSE
        
         Form_1.Release

  ENDIF

Return Nil


*------------------------------------------------*
FUNCTION eTVer_1()
*------------------------------------------------*

 IF lExistUSB( cDisk ) == .T.

    IF IsWindowActive("Form_1")
       ThisWindow.Title := "USB-PenDrive Detected OK !" 
       Form_1.Check_3.Enabled := .T.
    ENDIF

 ENDIF

 IF lExistUSB( cDisk ) == .F.
 
   IF IsWindowActive("Form_1")
      ThisWindow.Title := "USB-PenDrive Not Detected !" 
       Form_1.Check_3.Enabled := .F.
       Form_1.Label_03x.Value := "USB-PenDrive Not Detected !"
   ENDIF

 ENDIF

Return Nil


*---------------------------------------------------------------------------*

/* Se da el caso de que con un PenDrive (al menos el que yo he usado) las
   funciones IsDisk() y lIsDir() dan .F..
   Cuando se trata de una tarjeta de memoria (por ejemplo XD) insertada en
   un lector de tarjetas externo conectado a un puerto USB, la IsDisk() sigue
   dando .F. y la lIsDir() da .T..
   Com lo que se pretende es poder saber que unidades USB son susceptibles de
   usarse independientemente de PenDrive o tarjetas de memoria, se opta por
   la función GetDiskFreeSpace() que da .T. tanto para PenDrive como para
   tarjetas de memoria.
*/

*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
FUNCTION lExistUSB( cDisk ) // Autor da função: Carlos G.
*----------------------------------------------------------------------------*
*PRIVATE lExist        := .F.
*PRIVATE nSetErrorMode := 0
lExist        := .F.
nSetErrorMode := 0
nSetErrorMode := SETERRORMODE( 1 )
lExist := GetDiskFreeSpace( Left( cDisk, 1) + ":\" )
SETERRORMODE( nSetErrorMode )


Return lExist

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

#pragma BEGINDUMP

#include <windows.h>
#include <hbapi.h>
#include "hbapiitm.h" 

#ifndef __XHARBOUR__
   #define ISBYREF( n )          HB_ISBYREF( n )
   #define ISNIL( n )            HB_ISNIL( n )
#endif

// Code From WHAT32 by AJ Wos <andrwos@aust1.net> 

HB_FUNC(GETVOLUMEINFORMATION)
{
  char *VolumeNameBuffer     = (char *) hb_xgrab( MAX_PATH )  ;
  DWORD VolumeSerialNumber                                    ;
  DWORD MaximumComponentLength                                ;
  DWORD FileSystemFlags                                       ;
  char *FileSystemNameBuffer = (char *) hb_xgrab( MAX_PATH )  ;
  BOOL bRet;

  bRet = GetVolumeInformation( ISNIL(1) ? NULL : (LPCTSTR) hb_parc(1) ,
                                  (LPTSTR) VolumeNameBuffer           ,
                                  MAX_PATH                            ,
                                  &VolumeSerialNumber                 ,
                                  &MaximumComponentLength             ,
                                  &FileSystemFlags                    ,
                                  (LPTSTR)FileSystemNameBuffer        ,
                                  MAX_PATH ) ;
  if ( bRet  )
  {
     if ( ISBYREF( 2 ) )  hb_storc ((char *) VolumeNameBuffer, 2 )       ;
     if ( ISBYREF( 3 ) )  hb_stornl( (LONG)  VolumeSerialNumber, 3 )     ;
     if ( ISBYREF( 4 ) )  hb_stornl( (LONG)  MaximumComponentLength, 4 ) ;
     if ( ISBYREF( 5 ) )  hb_stornl( (LONG)  FileSystemFlags, 5 )        ;
     if ( ISBYREF( 6 ) )  hb_storc ((char *) FileSystemNameBuffer, 6 )   ;
  }

  hb_retl(bRet);
  hb_xfree( VolumeNameBuffer );
  hb_xfree( FileSystemNameBuffer );
}

HB_FUNC ( GETLOGICALDRIVES )
{
   hb_retnl( (DWORD) GetLogicalDrives() );
}

HB_FUNC ( GETDRIVETYPE )
{
   hb_retni( (UINT) GetDriveType(hb_parc(1)) );
}
HB_FUNC( SETERRORMODE )
{
   hb_retni( SetErrorMode( hb_parni( 1 ) ) ) ;
}

HB_FUNC( GETDISKFREESPACE ) // cRootPathName, @nSectorsByCluster, @nBytesPerSector,
                            // @nNumberOfFreeClusters, @nTotalNumberOfClusters --> lResult
{
   LPSTR lpRootPathName = hb_parc( 1 );
   DWORD SectorsPerCluster;
   DWORD BytesPerSector;
   DWORD NumberOfFreeClusters;
   DWORD TotalNumberOfClusters;

   hb_retl( GetDiskFreeSpace( lpRootPathName, &SectorsPerCluster,
                              &BytesPerSector, &NumberOfFreeClusters,
                              &TotalNumberOfClusters ) );
   hb_stornl( SectorsPerCluster, 2 );
   hb_stornl( BytesPerSector, 3 );
   hb_stornl( NumberOfFreeClusters, 4 );
   hb_stornl( TotalNumberOfClusters, 5 );
}
HB_FUNC( FILLBLUE )
{   
    HWND   hwnd;
    HBRUSH brush;
    RECT   rect;
    HDC    hdc;
    int    cx;
    int    cy;
    int    blue = 255;
    int    steps;
    int    i;

    hwnd  = (HWND) hb_parnl (1);
    hdc   = GetDC(hwnd);

    GetClientRect(hwnd, &rect);

    cx = rect.top;
    cy = rect.bottom;
    steps = (cy - cx) / 3;
    rect.bottom = 0;

    for( i = 0 ; i < steps ; i++ )
    {
        rect.bottom += 3;
        brush = CreateSolidBrush( RGB( 0, 148, blue ) );
        FillRect(hdc, &rect, brush);
        DeleteObject(brush);
        rect.top += 3;
        blue -= 1;
    }
    ReleaseDC(hwnd, hdc);
    hb_ret();
}
#pragma ENDDUMP

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

